<div class="add-general-space">
  <block-ui message="Loading..."></block-ui>

  <h3 *ngIf="expandCss === 'col-xl-6'" class="mb-3 mt-3 bold" id="heading">
    {{ addItem ? "Add General" : "Edit General" }}
  </h3>

  <div class="ml-5 mr-5">
    <app-alert [message]="message" [type]="type" id="alert"></app-alert>
  </div>
  <div [ngClass]="expandCss === 'col-xl-12' ? 'pl-3 pr-3' : 'pb-5'">
    <form [formGroup]="contactForm" autocomplete="off">
      <div class="form-group row">
        <div [ngClass]="expandCss">
          <div *ngIf="expandCss === 'col-xl-12'"><br/></div>
          <mat-expansion-panel expanded="true">
            <div class="d-flex justify-content-between align-items-center flex-wrap">
              <div class="d-flex justify-content-between align-items-center w-100 mb-3 mt-4">
                <h5 class="mb-0 text-left">Apply to location</h5>
                <kendo-switch formControlName="isAllowAllLocation" [onLabel]="'All'" [offLabel]="'Selected'"
                              (valueChange)="allLocationChange($event)"></kendo-switch>
              </div>
              <div class="d-flex justify-content-between align-items-center w-100 mb-3">
                <h5 class="mb-0">Status</h5>
                <kendo-switch formControlName="status" [onLabel]="'Active'" [offLabel]="'Inactive'">
                </kendo-switch>
              </div>

              <!-- Location  -->
              <div class="col-xl-12 d-flex align-items-center  pl-0 pr-0"
                   *ngIf="contactForm.get('isAllowAllLocation').value == false">
                <span>Location*</span>
              </div>
              <div class="col-xl-12 d-flex align-items-center  pl-0 pr-0"
                   *ngIf="contactForm.get('isAllowAllLocation').value == false" style="padding-bottom: 1.34375em;">
                <kendo-multiselect [data]="locationList" placeholder="Location Name" formControlName="locationName"
                                   [filterable]="true" [textField]="'locationName'" [valueField]="'id'">
                </kendo-multiselect>
              </div>
              <mat-error *ngIf="contactForm.get('locationName').hasError('required') && contactForm.get('locationName').touched">
                This field is required.
              </mat-error>

              <!-- Contact Category  -->
              <div class="col-xl-12 d-block align-items-center  pl-0 pr-0">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Contact Category*</mat-label>
                  <app-add-new-dropdown formControlName="categoryId" [categoryId]="contactCategoryParentId" [selectedId]="contactCategoryId"
                                        [value]="contactCategoryId"
                                        [disabled]="isDisabled"
                                        (appId)="appIdContactCategoryHandler($event)"></app-add-new-dropdown>
                  <mat-error *ngIf="contactForm.get('categoryId').hasError('required') && contactForm.get('locationName').touched">
                    This field is required.
                  </mat-error>
                </mat-form-field>
              </div>
            </div>
          </mat-expansion-panel>
          <br/>
          <mat-expansion-panel expanded="true">
            <mat-expansion-panel-header>
              <mat-panel-title class="text-left"> Basic Information</mat-panel-title>
              <mat-panel-description class="align-items-center"> Required</mat-panel-description>
            </mat-expansion-panel-header>
            <div class="row">
              <!-- Organisation Name  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Organisation Name</mat-label>
                  <input matInput placeholder="Organisation Name" formControlName="organisationName" required appCharLimit
                         [frmGroup]="contactForm" fcName="organisationName" [max]="100" />

                  <mat-error *ngIf="contactForm.get('organisationName').hasError('exceedLimit')">
                    {{contactForm.get('organisationName').getError('exceedLimit')}}
                  </mat-error>

                  <mat-error *ngIf="contactForm.get('organisationName').hasError('required')">
                    This field is required.
                  </mat-error>
                </mat-form-field>
              </div>

              <!-- Department Name  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Department Name</mat-label>
                  <input matInput placeholder="Department Name" formControlName="departmentName" appCharLimit
                         [frmGroup]="contactForm" fcName="departmentName" [max]="100" />

                  <mat-error *ngIf="contactForm.get('departmentName').hasError('exceedLimit')">
                    {{contactForm.get('departmentName').getError('exceedLimit')}}
                  </mat-error>
                </mat-form-field>
              </div>

              <!-- Title  -->
              <div class="col-xl-12">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Title</mat-label>
                  <app-add-new-dropdown [categoryId]="titleParentId" [selectedId]="titleId" [isRestrictSpecCharNum]="true"
                                        formControlName="titleId" (appId)="appIdTitleHandler($event)"></app-add-new-dropdown>
                </mat-form-field>
              </div>

              <!-- First Name  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>First Name</mat-label>
                  <input matInput placeholder="First Name" formControlName="firstName" required appCharLimit
                         [frmGroup]="contactForm" fcName="firstName" [max]="30" />

                  <mat-error *ngIf="contactForm.get('firstName').hasError('exceedLimit')">
                    {{contactForm.get('firstName').getError('exceedLimit')}}
                  </mat-error>

                  <mat-error *ngIf="contactForm.controls['firstName'].hasError('pattern')">
                    First name should only allow alphabets
                  </mat-error>

                  <mat-error *ngIf="contactForm.get('firstName').hasError('required')">
                    This field is required.
                  </mat-error>
                </mat-form-field>
              </div>

              <!-- Last Name  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Last Name</mat-label>
                  <input matInput placeholder="Last Name" formControlName="lastName" required appCharLimit
                         [frmGroup]="contactForm" fcName="lastName" [max]="30" />

                  <mat-error *ngIf="contactForm.get('lastName').hasError('exceedLimit')">
                    {{contactForm.get('lastName').getError('exceedLimit')}}
                  </mat-error>

                  <mat-error *ngIf="contactForm.controls['lastName'].hasError('pattern')">
                    Last name should only allow alphabets
                  </mat-error>

                  <mat-error *ngIf="contactForm.get('lastName').hasError('required')">
                    This field is required.
                  </mat-error>
                </mat-form-field>
              </div>

              <!-- Reference No  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Reference No</mat-label>
                  <input matInput placeholder="Reference No" formControlName="referenceNo" appCharLimit
                         [frmGroup]="contactForm" fcName="referenceNo" [max]="100" />

                  <mat-error *ngIf="contactForm.get('referenceNo').hasError('exceedLimit')">
                    {{contactForm.get('referenceNo').getError('exceedLimit')}}
                  </mat-error>
                </mat-form-field>
              </div>

              <!-- Notes  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Notes</mat-label>
                  <textarea matInput placeholder="Notes" formControlName="notes" rows="2"></textarea>
                </mat-form-field>
              </div>
            </div>
          </mat-expansion-panel>
          <div *ngIf="expandCss === 'col-xl-12'"><br/></div>
        </div>

        <div [ngClass]="expandCss">
          <mat-expansion-panel expanded="true">
            <mat-expansion-panel-header>
              <mat-panel-title class="text-left"> Contacts Information</mat-panel-title>
              <mat-panel-description class="align-items-center"> Required</mat-panel-description>
            </mat-expansion-panel-header>

            <div class="row">
              <!-- Address  -->
              <div class="col-xl-12">
                <app-address-field [addressForm]="contactForm" containerClass="add-general-space"></app-address-field>
              </div>

<!--              <div class="col-xl-12 d-flex justify-content-start">Address</div>-->
<!--              <div class="col-xl-12 d-block align-items-center mb-3">-->
<!--                <app-google-address [country]="country" [selectedAddress]="selectedAddress"-->
<!--                                    (address)="addressHandler($event)"-->
<!--                                    (addressManual)="addressManualHandler($event)"></app-google-address>-->
<!--              </div>-->

<!--              &lt;!&ndash; Country  &ndash;&gt;-->
<!--              <div class="col-xl-12 d-flex align-items-center">-->
<!--                <mat-form-field [appearance]="apperance" class="full-width">-->
<!--                  <mat-label>Country</mat-label>-->
<!--                  <input matInput placeholder="Country" formControlName="country"/>-->
<!--                </mat-form-field>-->
<!--              </div>-->

<!--              &lt;!&ndash; State  &ndash;&gt;-->
<!--              <div class="col-xl-12 d-flex align-items-center">-->
<!--                <mat-form-field [appearance]="apperance" class="full-width">-->
<!--                  <mat-label>State</mat-label>-->
<!--                  <input matInput placeholder="State" formControlName="state"/>-->
<!--                </mat-form-field>-->
<!--              </div>-->

<!--              &lt;!&ndash; City  &ndash;&gt;-->
<!--              <div class="col-xl-12 d-flex align-items-center">-->
<!--                <mat-form-field [appearance]="apperance" class="full-width">-->
<!--                  <mat-label>City</mat-label>-->
<!--                  <input matInput placeholder="City" formControlName="city"/>-->
<!--                </mat-form-field>-->
<!--              </div>-->
<!--              &lt;!&ndash; Post code  &ndash;&gt;-->
<!--              <div class="col-xl-12 d-flex align-items-center">-->
<!--                <mat-form-field [appearance]="apperance" class="full-width">-->
<!--                  <mat-label>Post code</mat-label>-->
<!--                  <input matInput placeholder="Post code" formControlName="postCode" type="number"/>-->
<!--                </mat-form-field>-->
<!--              </div>-->

              <!-- Work Phone  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Work Phone</mat-label>
                  <input matInput placeholder="Work Phone" formControlName="workPhone" type="text" appOnlyNumber />
                </mat-form-field>
              </div>

              <!-- Mobile  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Mobile</mat-label>
                  <input matInput placeholder="Mobile" formControlName="mobile" type="text" appOnlyNumber />
                </mat-form-field>
              </div>

              <!-- FAX  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>FAX</mat-label>
                  <input matInput placeholder="FAX" formControlName="fax" type="text" appOnlyNumber />
                </mat-form-field>
              </div>

              <!-- Email  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Email</mat-label>
                  <input matInput placeholder="Email id" formControlName="emailId" appCharLimit
                         [frmGroup]="contactForm" fcName="emailId" [max]="100" />

                  <mat-error *ngIf="contactForm.get('emailId').hasError('exceedLimit')">
                    {{contactForm.get('emailId').getError('exceedLimit')}}
                  </mat-error>

                  <mat-error *ngIf="contactForm.get('emailId').hasError('pattern')">
                    Please enter valid email address.
                  </mat-error>
                </mat-form-field>
              </div>

              <!-- Website  -->
              <div class="col-xl-12 d-flex align-items-center">
                <mat-form-field [appearance]="apperance" class="full-width">
                  <mat-label>Website</mat-label>
                  <input matInput placeholder="website" formControlName="website" appCharLimit
                         [frmGroup]="contactForm" fcName="website" [max]="100" />

                  <mat-error *ngIf="contactForm.get('website').hasError('exceedLimit')">
                    {{contactForm.get('website').getError('exceedLimit')}}
                  </mat-error>

                  <mat-error *ngIf="contactForm.get('emailId').hasError('pattern')">
                    Please enter a valid website URL
                  </mat-error>
                </mat-form-field>
              </div>
            </div>
          </mat-expansion-panel>
        </div>
      </div>
    </form>
  </div>

  <div class="text-right control-row">
    <mat-divider class=""></mat-divider>
    <div class="pt-3 d-flex justify-content-between align-items-center">
      <div class="deletebutton" *appAccess="GENERAL_MODULE;lookFor: 'D'">
        <button *ngIf="deleteButton" (click)="deleteContact()" mat-raised-button

                class="deletebutton-wrapper custom-delete-btn ml-2" color="accent">Delete
        </button>
      </div>
      <div style="width: 100%;">
        <button mat-stroked-button color="accent" class="mr-2" (click)="cancel()">Cancel</button>
        <button mat-raised-button color="accent" class="mr-2 wide"
                *appAccess="GENERAL_MODULE;lookFor: ['C','E']"
                [disabled]="contactForm.invalid || submitting"
                (click)="createGenaeralContact()">
          <div *ngIf="!submitting">Save</div>
          <div *ngIf="submitting">Saving...</div>
        </button>
      </div>
    </div>
  </div>
</div>
